local ascii = {}
for i = 0, 255
	ascii[i] = string.format("%03d", tostring(i))
end

local function MasterEmerald(v, p, c)
	--duh
	if p.mo.skin != "hypersonic" then return end
	if p.hypersonic == nil then return end
	if p.hypersonic.canplay != 2 then return end
	
	--No need to display health if there isn't any
	if not p.hypersonic.usinghealth then return end
	
	local tablething = {1}
	local string = "01"
	
	if p.hypersonic.emeraldframe and p.hypersonic.health > 0 then
		p.hypersonic.emeraldframe = $+1
		
		if p.hypersonic.health <= 30 then
			p.hypersonic.emeraldframe = $+1
		end
		
		if p.hypersonic.emeraldframe > 12 then
			p.hypersonic.emeraldframe = $-12
		end
		
		tablething[1] = p.hypersonic.emeraldframe
	else
		p.hypersonic.emeraldframe = 1
	end
	
	tablething[0] = "EMERALD"
	
	local shakex = p.hypersonic.hudshakex
	local shakey = p.hypersonic.hudshakey
	
	if p.hypersonic.health <= 0 then
		shakex = 0
		shakey = 0
	end
	
	local patch = v.cachePatch(table.concat(tablething, "", 0, 1))
	
	local scale = FRACUNIT
	if p.hypersonic.totaldisplays == 1 then
		scale = FRACUNIT*3/4
	elseif p.hypersonic.totaldisplays == 2 or p.hypersonic.totaldisplays == 3 or p.hypersonic.totaldisplays == 4 then
		scale = FRACUNIT/2
	end
	
	local x = 160*FRACUNIT
	if p.hypersonic.totaldisplays == 3 or p.hypersonic.totaldisplays == 4 then
		if p.splitscreenindex == 0 or p.splitscreenindex == 2 then
			x = 140*FRACUNIT
		elseif p.splitscreenindex == 1 or p.splitscreenindex == 3 then
			x = 180*FRACUNIT
		end
	end
	
	local y = 4*FRACUNIT
	local y2 = 6*FRACUNIT
	if p.hypersonic.totaldisplays == 2 then
		if p.splitscreenindex == 0 then
			y = -4*FRACUNIT
		elseif p.splitscreenindex == 1 then
			y = 96*FRACUNIT
		end
		y2 = 10*FRACUNIT
	elseif p.hypersonic.totaldisplays == 3 or p.hypersonic.totaldisplays == 4 then
		if p.splitscreenindex == 0 or p.splitscreenindex == 1 then
			y = -4*FRACUNIT
		elseif p.splitscreenindex == 2 or p.splitscreenindex == 3 then
			y = 168*FRACUNIT
		end
		y2 = 10*FRACUNIT
	end
	
	if p.hypersonic.oscillatescale == nil then
		p.hypersonic.oscillatescale = 0
		p.hypersonic.oscillatedirection = FRACUNIT/32
	else
		p.hypersonic.oscillatescale = $+p.hypersonic.oscillatedirection
		if p.hypersonic.oscillatescale >= FRACUNIT/4 then
			p.hypersonic.oscillatescale = FRACUNIT/4
			p.hypersonic.oscillatedirection = -FRACUNIT/32
		elseif p.hypersonic.oscillatescale <= 0 then
			p.hypersonic.oscillatescale = 0
			p.hypersonic.oscillatedirection = FRACUNIT/32
		end
	end
	
	if p.hypersonic.health > 30 or p.hypersonic.health <= 0 then
		p.hypersonic.oscillatescale = 0
	end
	
	scale = $+p.hypersonic.oscillatescale
	
	local colormap = v.getColormap("hypersonic", p.hypersonic.originalcolor)
	if p.hypersonic.health <= 0 then
		colormap = v.getColormap("hypersonic", SKINCOLOR_GREY)
	end
	
	v.drawScaled(x+shakex, y+shakey+18*FRACUNIT, scale, patch, V_HUDTRANS, colormap)
	
	if p.hypersonic.health != nil then
		local string = tostring(p.hypersonic.health)
		local characters = {}
		local length = 0
		for i = 1, string:len(string) do
			local character = string:sub(i, i)
			local number = patch.width/5
			if v.patchExists("MKFNT" + ascii[string:byte()]) then
				local patch = v.cachePatch("MKFNT" + ascii[character:byte()])
				length = $+number*(scale*4/3)
			else
				length = $+24*(scale*4/3)
			end
		end
		local xpos = -length/2
		for i = 1, string:len(string) do
			local character = string:sub(i, i)
			if v.patchExists("MKFNT" + ascii[character:byte()]) then
				if i == 1 then
					xpos = $+(scale*2/3)
				end
				v.drawScaled(x+xpos+shakex, y+shakey+y2-(4*(p.hypersonic.oscillatescale*4)), (scale*4/3), v.cachePatch("MKFNT" + ascii[character:byte()]), V_HUDTRANS, v.getColormap(p.mo.skin, p.hypersonic.originalcolor))
				//print(xpos)
				xpos = $+(patch.width/5)*(scale*4/3)
			else
				xpos = $+24*(scale*4/3)
			end
		end
	end
end

hud.add(MasterEmerald)